/*
 * io.c
 *
 *  Created on: 24.03.2011
 *      Author: kostochkin
 */

#include <avr/io.h>
#include "counter.h"

#define DAC_set_ref(ref) ({sync_dac_low;				\
		spi_send(0x00); 				\
		spi_send((((ref)>>8)&0xFF));	\
		spi_send(((ref)&0xFF));		\
		sync_dac_high;})
#define with_spi(foo) ({SPI_on;							\
		foo;							\
		SPI_off;})

void u_pch(unsigned char data) {
	while (!(UCSRA & (1 << 5)))
		;
	UDR = data;
}

unsigned char u_gch(void) {
	while (!(UCSRA & (1 << RXC)))
		;
	return UDR;
}

void spi_send(char cData) {
	SPDR = cData;
	while (!(SPSR & (1 << SPIF)))
		;
}

void set_dac_ref(int ref_v) {
	with_spi(DAC_set_ref(ref_v));
}

void read_eval_unit(void) {
	while (1) {
		counter_read_eval();
	}
}

void u_send_long(int high, int low) {
	u_pch((high >> 8) & 0xFF);
	u_pch(high & 0xFF);
	u_pch((low >> 8) & 0xFF);
	u_pch(low & 0xFF);
}

