/*
 * ftdi.c
 *
 *  Created on: 01.04.2011
 *      Author: kostochkin
 */
#include <windows.h>
#include <FTD2XX.H>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define count_error 0xFF000000

char buffer[4];


int FT_GetDevicesCount(void) {
	int count;
	if (FT_ListDevices(&count, 0, FT_LIST_NUMBER_ONLY) != FT_OK) {
		return 0;
	} else {
		return count;
	}
}

int FT_FindDeviceByDescription(char *description) {
	FT_STATUS status;
	char cnt[64];
	bool finded = false;
	int count = FT_GetDevicesCount();
	if (count>0) {
		do {
			count--;
			status = FT_ListDevices((PVOID)count, &cnt,
					FT_OPEN_BY_DESCRIPTION|FT_LIST_BY_INDEX);
			if (status==FT_OK) {
				finded = (strstr(cnt,description)!=0);
			};
			//else printf("error\n");
		} while (!(finded || (count < 0))) ;
		return count;
	}
	else return -1;

}

bool FT_openbydescription (char *devicename, FT_HANDLE* handle) {
	int deviceindex = FT_FindDeviceByDescription(devicename);
	bool result = false;
	if ((deviceindex>=0) &&
		(FT_Open(deviceindex,handle)==FT_OK)) {
		result = true;
	};
	return result;
}

bool FT_openbydescription2(char *devicename, FT_HANDLE* handle) {
	if (FT_OpenEx(devicename, FT_OPEN_BY_DESCRIPTION,handle)==FT_OK) {
		FT_SetBaudRate(*handle, 250000);
		FT_SetDataCharacteristics(*handle,8,2,0);
		FT_SetFlowControl(*handle,0,0,0);
		FT_SetTimeouts(*handle,100,100);
		FT_SetLatencyTimer(*handle, 5);
		return true;
	}
	else {
		return false;
	}
}

bool wait_answer(FT_HANDLE handle, DWORD bytes) {
	DWORD rx_bytes = 0;
	DWORD tx_bytes;
	DWORD eventword;
    DWORD lpBytesReturned;
    int timeoutTime = time(NULL) + 2;
    bool timeout = false;
	//printf("Wait for answer.");
    while (!((rx_bytes>=bytes)||timeout)) {
    	//printf(".");
		FT_GetStatus(handle, &rx_bytes, &tx_bytes, &eventword);
		Sleep(10);
		if (timeoutTime<(time(NULL))) timeout=true;
    };
	if (!timeout) {
		FT_Read(handle, (LPVOID)&buffer, bytes, &lpBytesReturned);
		//printf("Ok.\n");
	}
	else {
		strcpy(buffer,"\0\0\0\0");
		//printf("Timeout.\n");
	}
	return !timeout;
}

bool SendCommand (char command, int value, FT_HANDLE handle) {
	char out[2];
	//printf("Sending command %c0x%X. ",command, value);
	out[2] = ((char*)& value)[0];
	out[1] = ((char*)& value)[1];
	out[0] = command;
	//printf("send: %c , %X , %X\n", out[0], (unsigned int)out[1], (unsigned int)out[2]);
	DWORD written;
	FT_STATUS status=FT_Write(handle,&out,3,&written);
	//if (status==FT_OK) printf("Ok. ");
	return wait_answer(handle,1);
}

bool Set_Ref(int ref, FT_HANDLE handle) {
	return SendCommand('l', ref, handle);
}

bool StartCount(int counts, FT_HANDLE handle) {
	return SendCommand('g',counts,handle);
}

unsigned long GetCounts(FT_HANDLE devicehandle) {
	if (wait_answer(devicehandle,4)) {
		unsigned long ret=(buffer[0]*(256*256*256) + buffer[1]*(256*256) + buffer[2]*256 + buffer[3]);
		//printf("-- Return: %lu counts\n",ret);
		return ret;
	}
	return count_error;
}
